%define stable_part 2.1.0
%define development_part rc2

Name:           cosign
Version:        %stable_part
Release:        0.%development_part%{?dist}
Summary:        Secure, Intra-Institutional Web Authentication

Group:          System Environment/Daemons
License:        MIT?
URL:            http://www.umich.edu/~umweb/software/cosign/
Source0:        http://download.sourceforge.net/sourceforge/%name/%name-%version%development_part.tar.gz
Source1:        cosign.init
Patch1:		cosign-sasl2.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  httpd-devel, cyrus-sasl-devel, openssl-devel
Prereq:         /usr/sbin/useradd
Requires:       openssl-perl, httpd, mod_ssl


%description
An open source project originally designed to provide the University of
Michigan with a secure single sign-on web authentication system. cosign is
part of the National Science Foundation Middleware Initiative (NMI) EDIT
software release.


%prep
%setup -q -n %name-%version%development_part
%patch1 -p1


%build
%configure \
  --enable-apache2=%{_sbindir}/apxs \
  --enable-krb --with-gss \
  --with-cosignconf=%{_sysconfdir}/%{name}.conf \
  --with-cosigncadir=%{_sysconfdir}/pki/cosign/certs/CA \
  --with-cosigncert=%{_sysconfdir}/pki/cosign/certs/cert.pem \
  --with-cosignkey=%{_sysconfdir}/pki/cosign/certs/key.pem \
  --with-ticketcache=%{_var}/cosign/ticket
cd libsnet
%configure
cd ..
make %{?_smp_mflags} everything
chmod -x LICENSE VERSION README*


%install
rm -rf $RPM_BUILD_ROOT
LIBEXECDIR=$RPM_BUILD_ROOT/`apxs -q LIBEXECDIR`
mkdir -p $LIBEXECDIR
make install-all DESTDIR=$RPM_BUILD_ROOT \
  APXS2="apxs -S LIBEXECDIR=$LIBEXECDIR" \
  prefix=$RPM_BUILD_ROOT/%{_prefix} \
  CGIDIR=$RPM_BUILD_ROOT/%{_var}/www/cgi-bin \
  SBINDIR=$RPM_BUILD_ROOT/%{_sbindir} \
  MANDIR=$RPM_BUILD_ROOT/%{_mandir} \
  TMPLDIR=$RPM_BUILD_ROOT/%{_var}/www/cosign/templates \
  HTMLDIR=$RPM_BUILD_ROOT/%{_var}/www/cosign/html \
  SERVICESDIR=$RPM_BUILD_ROOT/%{_var}/www/cosign/services
# install dirs
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/pki/cosign/certs/CA \
  $RPM_BUILD_ROOT/%{_var}/cosign/{daemon,ticket}
# install init script
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/rc.d/init.d
cp -a %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/rc.d/init.d/cosign
# default config
cat << EOF > $RPM_BUILD_ROOT/%{_sysconfdir}/%{name}.conf
# TLS parameters
set cosigncadir /etc/pki/cosign/certs/CA
set cosigncert /etc/pki/cosign/certs/cert.pem
set cosignkey /etc/pki/cosign/certs/key.pem

cgi cgi-1
set cosigntmpldir /var/www/cosign/templates

# Grab this user's factor:
# - argument 3 and later are name(s) of <FORM>/POST fields from the template
# - at least one factor is required for authentication to succeed
# - a factor executable only returns 1 factor name
# - factor names can be used by mod_cosign (CosignRequireFactor)
# - "-2" means this secondary script is started only if another one was successf
ul
#factor /usr/lib/cosign/factor/123magic.sh login password
#factor /usr/lib/cosign/factor/ldap login password
#factor /usr/lib/cosign/factor/admin -2 login
EOF


%clean
rm -rf $RPM_BUILD_ROOT


%pre
/usr/sbin/useradd -c "COSIGN" -s /sbin/nologin -r -d /var/cosign/daemon cosign 2>/dev/null || :
# update /etc/services
getent services cosign >/dev/null \
  || echo "cosign 6663/tcp" >> /etc/services


%files
%defattr(-,root,root,-)
%doc CHANGELOG LICENSE README* VERSION scripts
%dir %{_sysconfdir}/pki/cosign
%dir %{_sysconfdir}/pki/cosign/certs
%dir %{_sysconfdir}/pki/cosign/certs/CA
%config(noreplace) %{_sysconfdir}/%{name}.conf
%{_sysconfdir}/rc.d/init.d/cosign
%dir %{_var}/www/cosign
%dir %{_var}/www/cosign/templates
%dir %{_var}/www/cosign/html
%dir %{_var}/www/cosign/services
%{_var}/www/cosign/templates/*
%{_var}/www/cosign/html/*
%{_var}/www/cosign/services/*
%{_var}/www/cgi-bin/*
%{_sbindir}/*
%{_mandir}/*/*
%{_libdir}/httpd/modules/*.so
%attr(-,cosign,cosign) %{_var}/cosign/daemon
%attr(770,cosign,apache) %{_var}/cosign/ticket


%changelog
* Fri Nov 7 2008 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
- initial release
